import type { Compound, Value } from "./values";
import type { DefaultPointer } from "./pointer";
import { Dictionary, Set } from "./dictionary";

export function isCompound<T = DefaultPointer>(x: Value<T>): x is Compound<T>
{
    return (Array.isArray(x) || Set.isSet(x) || Dictionary.isDictionary(x));
}
